{$N+,E-,G+}
program Aepfelmaennchen; {Zeit: 5:77}
uses
  graph,crt,dos,mndluni2,graphini,wandler,mandsave,mandmain,mandlpal;
type
  realZahl=extended;
  kZahl=record
          a,b: realZahl;
        end;
const
  versionText='Version 1.13 Vlado 1999';
  menueFarbe=5;
var
  maxx,maxy,genauigkeit: word;
  fAnker:pointer;
  aecke,becke,seite: realZahl;
  methode,xmf: byte;          {xmf = xMausFaktor}
  paletteDatei,stelleDatei: string;
  palette: xPalette;

procedure setzeStartWerte;
begin
  aecke:=-2;         {Realteil: -2}
  becke:=-2;         {Imaginaerteil: -1.5}
  seite:=4;          {Groesse des Ausschnitts: 3}
end;

procedure datenTeil(zeit:string);
var
  achtel: byte;
  x1,y1,x2,y2: word;
begin
  versteckeCursor;
  setfillstyle(1,0);
  bar((maxy+2),round(maxy * 10 / 20 - 1),maxx,round(maxy * 16 / 20));
  outtextxy(maxy+4,round(maxy * 15 / 20 + 1),'Zeit: '+zeit);
  outtextxy((maxy+10),round(maxy * 13 / 20),'Aufbau: '+int2str(methode));
  outtextxy((maxy+10),round(maxy * 14 / 20),'Max It: '+int2str(genauigkeit));
  achtel:=(maxx-maxy) div 8;
  setfillstyle(1,red);
  bar((maxy+(maxx-maxy) div 2),round(maxy * (16 / 20)),maxx,maxy);
  outtextxy((maxy+10+(maxx-maxy) div 2),round(maxy * 19 / 20),'Ende');
  outtextxy((maxy+10+(maxx-maxy) div 2),round(maxy * 17 / 20),'Reset');
  setfillstyle(1,blue);
  bar((maxy+2),round(maxy * 16 / 20),(maxy+(maxx-maxy) div 2),maxy);
  outtextxy((maxy+10),round(maxy * 18 / 20),'Los!');
  line((maxy+1),round(maxy * 16 / 20),maxx,round(maxy * 16 / 20));
  line((maxy+(maxx-maxy) div 2),(round(maxy * 16 / 20)+1),(maxy+(maxx-maxy) div 2),maxy);
  line((maxy+(maxx-maxy) div 2),round(maxy * 18 / 20),maxx,round(maxy * 18 / 20));
  getFeldxy('info',x1,y1,x2,y2, fAnker);
  rectangle(round((x1+1) / xmf - 1), y1, round((x2-1) / xmf + 1), y2);
  line((maxy+1),0,(maxy+1),maxy);
  zeigeCursor;
end; {datenTeil}

function getAusschnitt:boolean;
var
  feld: string;
  mausx,mausy,altmausx,altmausy,mausxk,ausschnitt,i: word;
  x1,y1,x2,y2,bx1,by1,bx2,by2,xBetrag,yBetrag: integer;
  tasteNr: byte;
  obenx,untenx,linksy,rechtsy:array[1..1024] of byte;
  bild:pointer;
 procedure machPassend(var von,bis:integer; platz: word);
 var
   hilf: word;
 begin
   hilf:=(bis-von);
   if hilf > round(platz - maxx / 64) then
   begin
     von:=round(von + (hilf-platz) / 2 + maxx / 64);
     bis:=round(bis - (hilf-platz) / 2 - maxx / 64);
   end;
 end;
 procedure loescheKasten;
 var
   z: integer;
 begin
   for z:=x1 to x2 do putpixel(z,y1,obenx[z]);
   for z:=x1 to x2 do putpixel(z,y2,untenx[z]);
   for z:=y1 to (y1+ausschnitt) do putpixel(x1,z,linksy[z]);
   for z:=y1 to (y1+ausschnitt) do putpixel(x2,z,rechtsy[z]);
 end;
begin
  ausschnitt:=0;
  x1:=0; x2:=0;
  setmouseWindow(0,0,maxy*xmf,maxy);
  setCursor(2);
  setcolor(15);
  getmausxy(altmausx,altmausy);
  altmausx:= altmausx div xmf;
  repeat
    repeat
      mausxk:=mausx;
      mauss(TasteNr,mausx,mausy,true);
      mausx:= mausx div xmf;
    until ((mausx<>mausxk)or(tasteNr>0));
    versteckeCursor;
    loescheKasten;
    if altmausx > mausx then xBetrag:=(altmausx-mausx)
                        else xBetrag:=(mausx-altmausx);
    if altmausy > mausy then yBetrag:=(altmausy-mausy)
                        else yBetrag:=(mausy-altmausy);
    if xBetrag > yBetrag then ausschnitt:=yBetrag else ausschnitt:=xBetrag;
    if altmausx > mausx then
    begin
      x2:=altmausx;
      x1:=(x2-ausschnitt);
    end
    else
    begin
      x1:=altmausx;
      x2:=(x1+ausschnitt);
    end;
    if altmausy > mausy then
    begin
      y2:=altmausy;
      y1:=(y2-ausschnitt);
    end
    else
    begin
      y1:=altmausy;
      y2:=(y1+ausschnitt);
    end;
    for i:=x1 to x2 do obenx[i]:=getpixel(i,y1);
    for i:=x1 to x2 do untenx[i]:=getpixel(i,y2);
    for i:=y1 to (y1+ausschnitt) do linksy[i]:=getpixel(x1,i);
    for i:=y1 to (y1+ausschnitt) do rechtsy[i]:=getpixel(x2,i);
    rectangle(x1,y1,x2,y2);
    zeigeCursor;
  until TasteNr>0;
  versteckeCursor;
  loescheKasten;
  zeigeCursor;
  if TasteNr=1 then
  begin
    versteckeCursor;
    aecke:=(aecke+((x1/maxy)*seite));
    becke:=(becke+(((maxy-y2)/maxy)*seite));
    seite:=((ausschnitt/maxy)*seite);
    machPassend(x1,x2,(maxx-maxy));
    machPassend(y1,y2,round(maxy * 10 / 20 - 2));
    setfillstyle(1,0);
    bar(maxy+2,0,maxx,round(maxy * 10 / 20 - 2));
    i:=imageSize(x1,y1,x2,y2);
    if maxAvail > i then
    begin
      getMem(bild,i);
      getImage(x1,y1,x2,y2,bild^);
      bX1:=round(maxy + 2 + (maxx - maxy) / 2 - (x2-x1) / 2);
      bY1:=round((maxy * 10/20 - 2) / 2 - (y2-y1) / 2);
      bX2:=(bX1 + x2 - x1);
      bY2:=(bY1 + y2 - y1);
      putImage(bX1, bY1, bild^, normalput);
      freeMem(bild,i);
    end;
    loescheFeld('info',fAnker);
    erzeugeFeld('info','Koordinaten(l) / Farben(r)',
      (bX1*xmf-1),(bY1-1),(bX2*xmf+1),(bY2+1),fAnker,1);
    rectangle((bX1-1), (bY1-1), (bX2+1), (bY2+1));
    getAusschnitt:=true;
    zeigeCursor;
  end
  else getAusschnitt:=false;
end; {getAusschnitt}

procedure info(var hauptfeld:string;allgemein:boolean);
var
  bild:pointer;
  mausx,mausy,x1,y1,x2,y2,groesse,maxFarb,trueColor: word;
  xMitte,yMitte: realZahl;
  feld: string;
  linkeTaste: boolean;
  hoehe,farbe,spalten,rot,gruen,blau: byte;
  ch:char;
  procedure dir(was:string);
  var
    DirInfo: SearchRec;
    i:byte;
  begin
    i:=0;
    outtextxy(round(x1+maxx/80),round(y1+maxy/70),'Vorhandene:');
    FindFirst(was, Archive, DirInfo);
    while ((DosError = 0) and ((i * 9 + 19) < (y2 - 10))) do
    begin
      inc(i);
      delete(dirInfo.name,(length(dirInfo.name)-3),length(dirInfo.name));
      outtextxy(round(x1+maxx/80),round(y1 + 10 + i * 9),dirInfo.name);
      FindNext(DirInfo);
    end;
  end;
  procedure eingabe(var variable:realZahl; ypos:word; minin,maxin:realZahl);
  var
    zk: string;
  begin
    versteckeCursor;
    zk:=ext2str(variable,22);
    textEingabe(zk,23,(maxx div 64),(ypos-1),4);
     if ((str2ext(zk)>=minin)and(str2ext(zk)<=maxin)) then variable:=str2ext(zk);
    zeigeCursor;
  end;
  procedure neueFarbe;
  begin
    setfillstyle(1,farbe);
    bar((y2 + 2),round(5 * maxy / 20 - 3),(x2-3),round(7 * maxy / 20 - 2));
    setfillstyle(1,menueFarbe);
    outtextxy(round(1.5 * y2 - 12),round(5.5 * maxy / 20),int2str(farbe));
    palette^.getRGB(farbe, rot, gruen, blau);
    bar((y2 + 5),round(8.5 * maxy / 20),(y2 + 93),round(9.5 * maxy / 20));
    outtextxy((y2 + 6),round(8.5 * maxy / 20 + 1),
      int2str(rot)+':'+int2str(gruen)+':'+int2str(blau));
  end;
  procedure paletteAusgeben;
  var
    i,j,k:byte;
  begin
    k:=0;
    for j:=0 to (spalten-1) do
    for i:=0 to (spalten-1) do
    begin
      setfillstyle(1,k);
      bar((x1+i*hoehe),(y1+j*hoehe),(x1+(i+1)*hoehe),(x1+(j+1)*hoehe));
      inc(k);
      line(y2,y1,y2,y2);
      rectangle(x1,y1,x2,y2);
    end;
  end;
begin
  x1:=2;
  y1:=2;
  x2:=(maxy-2);
  y2:=round(maxy * 10 / 20 -2);
  groesse:=imageSize(x1,y1,x2,y2);
  if maxAvail > groesse then
  begin
    setmouseWindow(0,0,maxx * xmf,round(maxy * 10 / 20 -2));
    getMem(bild,groesse);
    getImage(x1,y1,x2,y2,bild^);
    setfillstyle(1,menueFarbe);
    bar(x1,y1,x2,y2);
    erzeugeFeld('infoFeld','',0,0,maxy*xmf,y2,fAnker,2);
    if allgemein then
    begin
      xMitte:=(aecke + seite / 2);
      yMitte:=(becke + seite / 2);
      erzeugeFeld('seite','Gre der Seitenlngen',
        maxx * xmf div 64,round(maxy * 1 / 20 + 10),(maxx div 64 + 23 * 8) * xmf,round(maxy * 1 / 20 + 20),fAnker,10);
      erzeugeFeld('aecke','X-Koordinate des Bilmittelpunkts',
        maxx * xmf div 64,round(maxy * 3 / 20 + 10),(maxx div 64 + 23 * 8) * xmf,round(maxy * 3 / 20 + 20),fAnker,10);
      erzeugeFeld('becke','Y-Koordinate des Bilmittelpunkts',
        maxx * xmf div 64,round(maxy * 5 / 20 + 10),(maxx div 64 + 23 * 8) * xmf,round(maxy * 5 / 20 + 20),fAnker,10);
      erzeugeFeld('dateiname','Datei die geladen / gespeichert wird',
        round((y2+maxx/32)*xmf),round(maxy * 8 / 20),round(((y2+maxx/32)*xmf+96)*xmf),round(maxy*8/20 + 8),fAnker,10);
      erzeugeFeld('load','Ldt die Koordinaten aus der gewhlten Datei',
        round((y2+maxx/32*0.5)*xmf),round(maxy * 8 / 20 + 10),
        round((y2+maxx/32*0.5)*xmf+48),round(maxy * 8 / 20 + 18),fAnker,3);
      erzeugeFeld('save','Speichert Koordinaten unter eingegebenem Dateinamen',
        round((y2+maxx/32+maxx/32*4)*xmf),round(maxy*8/20+10),
        round((y2+maxx/32+maxx/32*4+32)*xmf),round(maxy*8/20+18),fAnker,3);
      rectangle(x1,y1,x2,y2);
      repeat
        versteckeCursor;
        bar((x1+1),(y1+1),(x2-1),round(maxy * 8 / 20 - 1));
        outtextxy(maxx div 64,round(maxy * 1 / 20),'Seitenlnge:');
        outtextxy(maxx div 64,round(maxy * 1 / 20 + 10),ext2str(seite,22));
        outtextxy(maxx div 64,round(maxy * 3 / 20),'x-Koordinate:');
        outtextxy(maxx div 64,round(maxy * 3 / 20 + 10),ext2str(xMitte,22));
        outtextxy(maxx div 64,round(maxy * 5 / 20),'y-Koordinate:');
        outtextxy(maxx div 64,round(maxy * 5 / 20 + 10),ext2str(yMitte,22));
        outtextxy(round(y2+maxx/32),round(maxy * 8 / 20),stelleDatei);
        outtextxy(round(y2+maxx/32*0.5),round(maxy * 8 / 20 + 10),'load');
        outtextxy(round(y2+maxx/32+maxx/32*4),round(maxy * 8 / 20 + 10),'save');
        zeigeCursor;
        maus(linkeTaste,feld,fAnker,true,ch);
        if feld='dateiname' then
        begin
          bar((x1+1),(y1+1),(x2-1),(round(maxy*8/20)-1));
          bar((x1+1),(y1+1),(y2-1),(y2-1));
          line(y2,y1,y2,y2);
          dir('*.vms');
          textEingabe(stelleDatei,11,round(y2+maxx/32),round(maxy*8/20),4);
          bar((x1+1),(y1+1),(y2-1),(y2-1));
          setcolor(menuefarbe);
          line(y2,(y1+1),y2,(y2-1));
          setcolor(15);
        end;
        if feld='save' then
        begin
          stelleSpeichern(erweiterung(stelleDatei,'.vms'),xMitte,yMitte,seite);
          outtextxy(round(y1 + (y2-y1)/2 - 24),round(maxy * 8 / 20),'saved!');
        end;
        if feld='load' then
        begin
          stelleLaden(erweiterung(stelleDatei,'.vms'),xMitte,yMitte,seite);
          outtextxy(round(y1 + (y2-y1)/2 - 28),round(maxy * 8 / 20),'loaded!');
        end;
        if feld='seite' then eingabe(seite,round(maxy * 1 / 20 + 10), 0, 100);
        if feld='aecke' then eingabe(xMitte,round(maxy * 3 / 20 + 10), -2, 2);
        if feld='becke' then eingabe(yMitte,round(maxy * 5 / 20 + 10), -2, 2);
      until feld='info';
      loeschefeld('load',fAnker);
      loeschefeld('save',fAnker);
      loeschefeld('dateiname',fAnker);
      loeschefeld('becke',fAnker);
      loeschefeld('aecke',fAnker);
      loeschefeld('seite',fAnker);
      aecke:=(xMitte - seite / 2);
      becke:=(yMitte - seite / 2);
    end
    else
    begin
      farbe:=0;
      ch:=' ';
      spalten:=round(sqrt(getmaxcolor));
      hoehe:=(y2-y1) div (spalten);
      paletteAusgeben;
      erzeugeFeld('farben','Welche Farbe ndern?',((x1+2)*xmf),(y1+2),y2*xmf,y2,fAnker,16);
      maxFarb:=getmaxcolor;
      rot:=0; gruen:=0; blau:=0;
      outtextxy((y2 + 6),round(7.5 * maxy / 20 + 1),' r: g: b');
      outtextxy((y2 + 6),round(1 * maxy / 20 + 1),'Dateiname:');
      outtextxy((y2 + 3),round(2 * maxy / 20 + 1),paletteDatei);
      outtextxy((y2 + 4),round(3 * maxy / 20),'save   load');
      outtextxy((y2 + 2),round(5 * maxy / 20 - 3),'Ziffernblock');
      outtextxy((y2 + 20),round(6 * maxy / 20 - 3),'nutzen!');
      erzeugeFeld('dateiname','Datei die geladen / gespeichert wird',
        xmf*(y2 + 3),round(2 * maxy / 20 + 1),xmf*(y2 + 99),round(3 * maxy / 20 + 1),fAnker,10);
      erzeugeFeld('save','Palette in Datei speichern',
        xmf*(y2 + 4),round(3 * maxy / 20),xmf*(y2 + 36),round(4 * maxy / 20),fAnker,3);
      erzeugeFeld('load','Palette aus Datei laden',
        xmf*(y2 + 58),round(3 * maxy / 20),xmf*(y2 + 92),round(4 * maxy / 20),fAnker,3);
      repeat
        maus(linkeTaste,feld,fAnker,false,ch);
        if ch<>' ' then
        begin
          case ch of
            '7': inc(rot);
            '1': dec(rot);
            '8': inc(gruen);
            '2': dec(gruen);
            '9': inc(blau);
            '3': dec(blau);
            '4': if farbe > 0 then dec(farbe);
            '6': if farbe < maxFarb then inc(farbe);
            '+': begin inc(rot); inc(gruen); inc(blau); end;
            '-': begin dec(rot); dec(gruen); dec(blau); end;
            '5': if farbe > 0 then
                 begin
                   palette^.getRGB((farbe - 1), rot, gruen, blau);
                   palette^.setRGB(farbe, rot, gruen, blau);
                 end;
            'l': feld:='load';
            char(27): feld:='info';
          end;
          if ((ch='4')or(ch='6')) then neueFarbe else palette^.setRGB(farbe,rot,gruen,blau);
          bar((y2 + 5),round(8.5 * maxy / 20),(y2 + 93),round(9.5 * maxy / 20));
          outtextxy((y2 + 6),round(8.5 * maxy / 20 + 1),int2str(rot)+':'+int2str(gruen)+':'+int2str(blau));
          ch:=' ';
        end;
        if feld='dateiname' then
        begin
          setfillstyle(1,menueFarbe);
          bar((x1+1),(y1+1),(y2-1),(y2-1));
          dir('*.vmp');
          textEingabe(paletteDatei,12,(y2 + 3),round(2 * maxy / 20 + 1),4);
          paletteAusgeben;
          setfillstyle(1,menueFarbe);
        end;
        if feld='save' then
        begin
          setfillstyle(1,menueFarbe);
          palette^.speichern(erweiterung(paletteDatei,'.vmp'));
          bar((y2 + 2),round(5 * maxy / 20 - 3),(x2-3),round(7 * maxy / 20 - 2));
          outtextxy(round(1.2 * y2),round(5.5 * maxy / 20),'saved!');
        end;
        if feld='load' then
        begin
          setfillstyle(1,menueFarbe);
          palette^.laden(erweiterung(paletteDatei,'.vmp'));
          bar((y2 + 2),round(5 * maxy / 20 - 3),(x2-3),round(7 * maxy / 20 - 2));
          outtextxy(round(1.2 * y2),round(5.5 * maxy / 20),'loaded!');
        end;
        if feld='farben' then
        begin
          getmausxy(mausx,mausy);
          farbe:=trunc((mausx div xmf-x1)/hoehe)+spalten*trunc((mausy-y1)/hoehe);
          neueFarbe;
        end;
      until feld='info';
    end;
    loescheFeld('dateiname',fAnker);
    loescheFeld('save',fAnker);
    loescheFeld('load',fAnker);
    loescheFeld('farben',fAnker);
    loescheFeld('infoFeld',fAnker);
    setmouseWindow(0,0,maxx * xmf,maxy);
    putImage(x1,y1, bild^, normalput);
    freeMem(bild,groesse);
  end;
end; {info}

procedure HauptTeil;
var
  linkeTaste: boolean;
  ch: char;
  feld: string;
  std,min,sec,hsec:word;
  dauer:string[10];
  eingabe:string;
begin
  ch:=' ';
  setPos((maxy + (maxx - maxy) div 2) * xmf, maxy div 3);
  setmouseWindow((maxy+2) * xmf,0,maxx * xmf,maxy);
  setCursor(8);
  gettime(std,min,sec,hsec);
  main(maxx,maxy,genauigkeit,aecke,becke,seite,methode);
  genauigkeit:=500;
  dauer:=zeit(std,min,sec,hsec);
  repeat
    datenTeil(dauer);
    setmouseWindow(0,0,maxx * xmf,maxy);
    ch:=' ';
    maus(linkeTaste,feld,fAnker,true,ch);
    case ch of
      char(27): feld:='ende';
      's': begin
            versteckeCursor;
            schoner;
            feld:='akt';
            datenTeil(dauer);
            zeigeCursor;
        end;
      'f': begin feld:='info'; linkeTaste:=false; end;
      'p': palette^.neueLaden(paletteDatei);
    end;
    if feld='info' then Info(feld,linkeTaste);
    if feld='bild' then
    begin
      if GetAusschnitt then
      begin
        setMouseWindow(0,0,maxx * xmf,maxy);
        setPos((maxy + (maxx - maxy) div 2) * xmf, maxy div 3);
        feld:='akt';
      end;
    end;
    if feld='reset' then setzeStartWerte;
    if ((feld='akt')or(feld='reset')) then
    begin
      setmouseWindow((maxy+2) * xmf,0,maxx * xmf,maxy);
      setCursor(8);
      zeigeCursor;
      gettime(std,min,sec,hsec);
      main(maxx,maxy,genauigkeit,aecke,becke,seite,methode);
      dauer:=zeit(std,min,sec,hsec);
    end;
    if feld='genau' then
    begin
      textEingabe(eingabe,5,(maxy+74),round(maxy * 14 / 20),4);
      if str2int(eingabe) > 0 then genauigkeit:=str2int(eingabe);
      datenTeil('');
    end;
    if feld='methode' then
    begin
      if linkeTaste then inc(methode) else
        if methode > 0 then dec(methode);
      datenTeil('');
    end;
  until feld='ende';
end;

procedure Init;
var
  achtel:byte;
begin
  randomize;
  setzeStartWerte;
  paletteDatei:='norm'+int2str(getmaxcolor+1)+'.vmp';
  new(palette);
  palette^.init(getmaxcolor,paletteDatei);
  aecke:=0;
  becke:=0;
  seite:=4;
  stelleDatei:='norm.vms';
  stelleLaden(stelleDatei,aecke,becke,seite);
  aecke:=(aecke - seite / 2);
  becke:=(becke - seite / 2);
  methode:=0;
  genauigkeit:=100;
  if maxx=319 then xmf:=2 else xmf:=1;
  versteckeCursor;
  setfillstyle(1,blue);
  bar(0,0,maxy,maxy);
  setcolor(15);
  if maxy > 400 then
  begin
    settextstyle(1,0,1);
    outtextxy(maxx div 100,maxy div 30 * 27,'Zoom-in-die-Mandelbrot-Menge-Programm');
  end
  else outtextxy(maxx div 100,maxy div 30 * 27,'MandelZoom');
  settextstyle(0,0,1);
  graphinfo(maxx div 64, maxy div 30 * 18);
  outtextxy(maxx div 100,maxy div 30 * 29,versionText);
  erzeugeFeld('main','',0,0,maxx * xmf,maxy,fAnker,2);
  erzeugeFeld('bild','1. Klicken(l) 2. ziehen 3. Endpunkt(l)/abbrechen(r)',
    0,0,maxy*xmf,maxy,fAnker,17);
  erzeugeFeld('methode','l: naechste r: vorherige',(maxy+10)*xmf,round(maxy * 13 / 20),
    (maxy + 10 + 12 * 8) * xmf,round(maxy * 13 / 20 + 10),fAnker,9);
  erzeugeFeld('genau','wie weit (und lange) rechnen?',
    (maxy+10)*xmf,round(maxy * 14 / 20),(maxy + 10 + 12 * 8) * xmf,round(maxy * 14 / 20 +10),fAnker,10);
  erzeugeFeld('ende','Und Tsch...',(maxy+(maxx-maxy) div 2)*xmf,
    round(maxy * 18 / 20),maxx * xmf,maxy,fAnker,4);
  erzeugeFeld('reset','Ausgangswerte',(maxy+(maxx-maxy) div 2)*xmf,
    round(maxy * 16 / 20),maxx * xmf,round(maxy * 18 / 20),fAnker,6);
  erzeugeFeld('akt','Berechnung starten',(maxy+2)*xmf,round(maxy * 16 / 20),
    (maxy+(maxx-maxy) div 2)*xmf,maxy,fAnker,7);
  achtel:=(maxx-maxy) div 8;
  erzeugeFeld('info','Koordinaten(l) / Farben(r)',(maxy+(maxx-maxy) div 6)*xmf,
    round(maxy * 1 / 20),(maxx - (maxx-maxy) div 6) * xmf,round(maxy * 4 / 20),fAnker,1);
  bar((maxy+(maxx-maxy) div 6),round(maxy * 1 / 20),(maxx-(maxx-maxy) div 6),round(maxy * 4 / 20));
  line((maxy+(maxx-maxy) div 6),round(maxy * 1 / 20),(maxx-(maxx-maxy) div 6),round(maxy * 4 / 20));
  outtextxy((maxy+5+(maxx-maxy) div 6),round(maxy * 3 / 20),'Stelle');
  outtextxy((maxx-53-(maxx-maxy) div 6),round(maxy * 2 / 20 - 8),'Farben');
  datenTeil('');
  zeigeCursor;
end;

begin
  if graphinit('egavga',2) then
  begin
    fAnker:=nil;
    maxx:=getmaxx;
    maxy:=getmaxy;
    if mausinit then
    begin
      Init;
      HauptTeil;
      loescheAlle(fAnker);
      palette^.ende;
      closegraph;
    end
    else
    begin
      closegraph;
      writeln('Maustreiber nicht gefunden - Programm abgebrochen!');
      writeln('<Eingabe> drcken, um zu beenden...');
      readln;
    end;
  end;
end.
{$N-,E+,G-}